package be.jeffcheasey88.peeratcode.parser.java;

import java.util.Map;
import java.util.function.Function;

import be.jeffcheasey88.peeratcode.parser.Token;

public class Annotation extends JavaElement{
	
	public static interface Annotable{
		
		void addAnnotation(Annotation annotation);
		
	}
	
	private Token name;
	private Map<Token, Value> values;
	
	public Annotation(Token name){
		this.name = name;
	}
	
	public Annotation(Token name, Map<Token, Value> values){
		this(name);
		this.values =  values;
	}
	
	public Token getName(){
		return name;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder){
		for(Value value : this.values.values()){
			if(finder.apply(value)) return (E)value;
		}
		return null;
	}

}
